import { CommentRenderer } from "./comment-renderer";
import { CDataRenderer } from "./cdata-renderer";
export class Renderer {
  constructor(renderers = new Array()) {
    this.renderers = renderers;
  }
  renderNode(node) {
    const renderer = this.getRenderer(node);
    if (renderer) {
      return renderer.render(node);
    }
    return null;
  }
  getRenderer(node) {
    if (!node) {
      return null;
    }
    if (node.nodeName.toLowerCase() === "#comment") {
      let cr = this.renderers.find(e => e instanceof CommentRenderer);
      if (!cr) {
        cr = new CommentRenderer();
        this.renderers.push(cr);
      }
      return cr;
    }
    else if (node.nodeName.toLowerCase() === `#cdata-section`) {
      let r = this.renderers.find(e => e instanceof CDataRenderer);
      if (!r) {
        r = new CDataRenderer();
        this.renderers.push(r);
      }
      return r;
    }
    return null;
  }
}
